-- button lua

button = class:new()


function button:init()
	
	self.table = {}
	self.img = { "gfx/button_1.png" , "gfx/button_2.png" }

end


function button:new( Type, text, x, y, s )

	local temp = 	{	
						img = lg.newImage( self.img[Type] ),
						x = x,
						y = y,
						ox = 32,
						oy = 32,
						Rad = 0,
						sel = false,
						Type = Type,
						text = text,
						s = s or 0,
					}
					
		temp.w = temp.img:getWidth()
		temp.h = temp.img:getHeight()
					
	table.insert( self.table, temp )

end


function button:update( dt )

	for i,v in ipairs( self.table ) do
		
		v.hitbox = { x = v.x - v.ox, y = v.y - v.oy, w = v.w, h = v.h}
		
		v.Rad = v.Rad + v.s * dt
		if v.Rad >= 360 * math.pi / 180 then v.Rad = 0 end
		
		if boxCollide( mouse_hitbox, v.hitbox ) then v.sel = true
		else v.sel = false end
			

	end

end


function button:draw()

	for i,v in ipairs( self.table ) do
		
		if v.sel then
			lg.setColor( 255, 255, 255 )
		else
			lg.setColor( 200, 200, 200 )
		end
		
		lg.draw( v.img, v.x, v.y, v.Rad, 1, 1, v.ox, v.oy )
		lg.setColor( 25, 25, 25 )
		lg.printf( v.text, v.x - v.ox + (v.w / 2) - 50, v.y + (v.h / 2) - v.oy - 16, 100, "center" )
	
	end	

end
