-- combine lua
require 'lua/gameover'

combine = class:new()


function combine:init()
	
	self.table = {}
	self.timer = 0
	self.countdownTimer = 0
	self.img = lg.newImage("gfx/dreamObj.png")
	self.solved = true
	self.solveTime = 0
	self.counter = 0
	
	self.up = { 
				{ 	
					id = 1,
					img = lg.newImage( 'gfx/upFullTime.png' ), 
					used = false,
					x = 330,
					y = 30,
					alpha = 0,
					sel = false,
				}, 
				
				{ 	
					id = 2,
					img = lg.newImage( 'gfx/upJoker.png' ),
					used = false,
					x = 362,
					y = 30,
					alpha = 0,
					sel = false,
				},
					
			}

end


function combine:newIcon()

	local temp = {
					x = 440,
					y = 0,
					iconId = math.random( 1, dreamobj.selection ),
					alpha = 0,
					
				}
	temp.w = self.img:getWidth()
	temp.h = self.img:getHeight()
	
	table.insert( self.table, temp )

end


function combine:newCombination( count, Time )

	for i = 1, count do
		combine:newIcon()
		self.table[i].y = self.table[i].y + ( 64 * i )
	end
	
	self.solveTime = Time

end


function combine:update( dt )

	if self.solved then self.timer = self.timer + dt end
	
	if self.timer > 1 then
		if self.counter < 5 then
			combine:newCombination( 3, 20 )
		elseif self.counter >= 5 and self.counter < 10 then
			combine:newCombination( 4, 15 )
			dreamobj.selection = 4
		elseif self.counter >= 10 and self.counter < 15 then
			combine:newCombination( 5, 15 )
			dreamobj.selection = 6
		else combine:newCombination( 5, 15 )
			dreamobj.selection = 7
		end
		
		self.solved = false
		self.countdownTimer = self.solveTime
		self.timer = 0
	end
	
	if self.countdownTimer > 0 and not self.solved then self.countdownTimer = self.countdownTimer - dt
	elseif self.countdownTimer < 0 then
		fader.r, fader.g, fader.b = 255, 255, 255
		fader.speed = 800
		fadeTo( gameover ) 
	end
	
	for z,q in ipairs( dreamobj.table ) do
		for i,v in ipairs( self.table ) do
	
			if v.alpha < 254 then v.alpha = v.alpha + 100 * dt end
		
			if q.clicked and v.iconId == q.iconId and i == 1 then 
				table.remove( self.table, i )
				table.remove( dreamobj.table, z )
			end
			
			if #self.table == 0 then
				self.solved = true
				Write[math.random(1, 2)]:play()
				self.counter = self.counter + 1
			end
		end
	end
	
	for i,v in ipairs( self.up ) do
	
		v.hitbox = { x = v.x, y = v.y, w = 28, h = 28 }
		
		if v.alpha < 254 then v.alpha = v.alpha + 75 * dt end
		
		if boxCollide( mouse_hitbox, v.hitbox ) then
		
			v.sel = true
			
			if lm.isDown( 'l' ) and not v.used then
				if v.id == 1 then
					v.used = true
					self.countdownTimer = 20
					table.remove( self.up, i )
				elseif v.id == 2 then
					v.used = true
					self.table = {}
					self.solved = true
					Write[math.random(1, 2)]:play()
					table.remove( self.up, i )
				end
			end
			
		else v.sel = false
		end
		
	end

end


function combine:draw()

	for i,v in ipairs( self.table ) do
	
		lg.setColor( 255, 255, 255, v.alpha )
		lg.draw( self.img, v.x, v.y, 0, 2, 2)
		lg.setColor( 150, 150, 150, v.alpha )
		lg.draw( dreamobj.icon[v.iconId], v.x + v.w / 2, v.y + v.h / 2 )
	
		lg.setColor( 50, 50, 175, v.alpha )
		lg.rectangle( "fill", 465, self.table[#self.table].y + 64, 16, self.countdownTimer * 5 )

	end
	
	for i,v in ipairs( self.up ) do
	
		if not v.used then
		
			if v.sel then
				lg.setColor( 255, 255, 255, v.alpha )
			else
				lg.setColor( 200, 200, 200, v.alpha )
			end
			
			lg.draw( v.img, v.x, v.y )
		end
	
	end
	
		lg.setColor( 255, 255, 255 )
		lg.printf( "Remembered dreams: "..self.counter, 467 - 30, 10, 60, "center" )
		
end
