-- credits lua

credits = gamestate:new()


function credits:init()
		
	self.text = {}
	for line in lf.lines("Credits.txt") do
		table.insert(self.text, line)
	end
	
	self.loveImg = lg.newImage( 'gfx/lovepowered.png' )
	
	self.textLength = 400
	


end


function credits:enter()

	self:init()
	stars:init()

	button:init()
	button:new( 2, "Back", width / 2 - 32, height - 64)

end


function credits:update( dt )

	button:update( dt )
	stars:update( dt )

end


function credits:draw()
	
	stars:draw()
	
	for i = 1, #self.text do
	
		lg.setColor(255, 255, 255)
		lg.printf(tostring(self.text[i]), width / 2 - self.textLength / 2, 0 + ( 15 * i ) , self.textLength, "center")
		
	end
	
	lg.setColor( 255, 255, 255, 10 )
	lg.draw( self.loveImg, width / 4 ,height - self.loveImg:getHeight() + 64 , 0, .5, .5 )
	button:draw()

end


function credits:keypressed( key )

	if key == "escape" then 
		fadeTo( menu )
	end

end


function credits:mousepressed( x, y, b )

	if b == "l" then
	
		if button.table[1].sel then fadeTo( menu ) end
		onClick:play()
	end

end