-- button lua

dreamobj = class:new()


function dreamobj:init()
	
	self.table = {}
	self.timer = 0
	self.selection = 3
	self.img = { "gfx/dreamObj.png" }
	self.icon = {
					lg.newImage( 'gfx/icon_flower.png' ),
					lg.newImage( 'gfx/icon_rocket.png' ),
					lg.newImage( 'gfx/icon_idea.png' ),
					lg.newImage( 'gfx/icon_book.png' ),
					lg.newImage( 'gfx/icon_eule.png' ),
					lg.newImage( 'gfx/icon_house.png' ),
					lg.newImage( 'gfx/icon_pc.png' ),
				}
				
	for i = 1, #self.icon do
		self.icon[i]:setFilter( "nearest", "nearest" )
	end
				
	self.rate = .4

end


function dreamobj:new()

	local temp = 	{	
						img = lg.newImage( self.img[1] ),
						x = math.random( 30, 400 ),
						y = 480,
						ox = 16,
						oy = 16,
						Rad = 0,
						sel = false,
						Type = Type,
						iconId = math.random(1, self.selection),
						text = text,
						clicked = false,
						alpha = 0,
						s = 140,
						red = math.random( 100, 255 ),
						green = math.random( 100, 255 ),
						blue = math.random( 100, 255 ),
					}
					
		temp.w = temp.img:getWidth()
		temp.h = temp.img:getHeight()
					
	table.insert( self.table, temp )

end


function dreamobj:update( dt )

	self.timer = self.timer + dt
				
	if self.timer > self.rate then
	
		dreamobj:new()
		self.timer = 0
	
	end

	for i,v in ipairs( self.table ) do
		
		if v.alpha < 254 then v.alpha = v.alpha + 300 * dt end
		
		v.hitbox = { x = v.x - v.ox * 2, y = v.y - v.oy * 2, w = v.w * 1.5, h = v.h * 1.5}
		
		v.Rad = v.Rad + 2 * dt
		if v.Rad >= 360 * math.pi / 180 then v.Rad = 0 end
		
		if boxCollide( mouse_hitbox, v.hitbox ) then

			v.sel = true
			
			if lm.isDown( 'l' ) then v.clicked = true
			else v.clicked = false
			end
		
		else v.sel = false
		end
		
		if combine.counter >= 10 and combine.counter < 15 then
			v.s  = 160
		elseif combine.counter >= 15 and combine.counter < 20 then
			v.s  = 180
			self.rate = .3
		elseif combine.counter >= 20 and combine.counter < 25 then
			v.s = 220
			self.rate = .2
		elseif combine.counter >= 25 and combine.counter < 30 then
			v.s = 240
		elseif combine.counter >= 30 then
			v.s = 260
			self.rate = .25
		end
			
		v.y = v.y - v.s * dt
		
		if v.y < - v.h then table.remove( self.table, i ) end

	end

end


function dreamobj:draw()

	for i,v in ipairs( self.table ) do
		
		if v.sel then
			lg.setColor( v.red, v.green, v.blue, v.alpha )
		else
			lg.setColor( v.red - 50, v.green - 50, v.blue - 50, v.alpha )
		end
		
		lg.push()
		lg.setScissor( 30, 20, 390, 500 )
		lg.draw( v.img, v.x, v.y, v.Rad, 2, 2, v.ox, v.oy )
		lg.setColor( 255, 255, 255, v.alpha )
		lg.draw( self.icon[v.iconId], v.x, v.y, 0, 1, 1, v.ox, v.oy )
		lg.setScissor( 0, 0, 512, 512 )
		lg.pop()
	
	end	

end
