-- game lua
require 'lua/dreamobject'
require 'lua/combine'

game = gamestate:new()


function game:init()
	
	self.pause = false
	self.img = lg.newImage( 'gfx/diarypage.png' )

end


function game:enter()

	self:init()
	dreamobj:init()
	combine:init()

end


function game:update( dt )

	if not self.pause then
		
		dreamobj:update( dt )
		combine:update( dt )
	
	end

end


function game:draw()
	
	lg.setColor( 200, 200, 200 )
	lg.draw( self.img, 0, 0 )	
	dreamobj:draw()
	combine:draw()
	
	lg.setColor( 255, 255, 255 )
	if self.pause then lg.printf( "PAUSED", width / 2 - 50, height / 2, 100, "center" ) end

end


function game:keypressed( key )

	if key == "escape" then 
		fadeTo( menu )
	elseif key == "p" then 	
		self.pause = not self.pause
	end

end