-- menu lua
require 'lua/button'
require "lua/game"
require "lua/credits"

menu = gamestate:new()


function menu:init()
	
	self.img = lg.newImage( "gfx/back_menu.png" )

end


function menu:enter()
	
	self:init()
	
	button:init()
	button:new( 1, "Go", 195, height - 128, .5 )
	
	button:new( 2, "Exit", 96, height - 64)
	button:new( 2, "Credits", 96 + 128, height - 64)

end


function menu:update( dt )

	button:update( dt )

end


function menu:draw()
	
	lg.setColor( 255, 255, 255 )
	lg.draw( self.img, 0, 0 )
	lg.printf( " Use the mouse to click the different parts out of your dreams. Make sure you do so in the right order. ", width / 2 - 160, 100, 200, "center" )
	lg.print( " Entry for the Bacon Game Jam #4 ", 0, height - 24)
	button:draw()

end


function menu:keypressed( key )

	if key == "escape" then 
		love.event.push( 'quit' ) 	
	end
	
	sfxmanager.keypressed( key )

end


function menu:mousepressed( x, y, b )

	if b == "l" then
	
		if button.table[1].sel then
			fadeTo( game )
			sel_lvl = 1
			dream[math.random(1, 2)]:play()
		elseif button.table[2].sel then fadeTo( "exit" )
		elseif button.table[3].sel then fadeTo( credits )
		end
		
		onClick:play()
	end

end