-- stars lua

stars = class:new()


function stars:init()
	
	self.img = lg.newImage( "gfx/star.png" )
	self.table = {}
	self.count = 32
	self.rate = .2
	self.timer = 0
	
end


function stars:update( dt )

	self.timer = self.timer + dt
				
	if #self.table < self.count and self.timer > self.rate then
	
		-- Generate stars
		local temp = {
				
						x = math.random( 0, width ),
						y = -16,
						s = math.random( 180, 220 ),
					
					}	
				
		table.insert( self.table, temp )
		self.timer = 0
	end
	
	for i,v in ipairs( self.table ) do
	
		v.y = v.y + v.s * dt
		
		if v.y > height then table.remove(self.table, i) end
		
	end

end


function stars:draw()

	lg.setColor( 100, 100, 100 )

	for i,v in ipairs( self.table ) do
		
		lg.draw( self.img, v.x, v.y, 0, 2 )
		
	end

end