-- main lua

Class = require "lib/class"
gamestate = require "lib/gamestate"

require "lua/menu"
require "lua/fader"
require "lua/soundmanager"
require 'lua/stars'
	
lg = love.graphics
lt = love.timer
lm = love.mouse
le = love.event
lk = love.keyboard
lf = love.filesystem
la = love.audio

function love.load()

	width = lg.getWidth()
	height = lg.getHeight()
	
	math.randomseed( os.time() )
	
	gamestate.switch( menu )
	gamestate.init()
	
	fader:init()
	
	font = lg.newFont( 'font.ttf', 16 )
	lg.setFont( font )
	
	sfxmanager:init()
	
	cursor = lg.newImage( "gfx/cursor.png" )
	cursor:setFilter( "nearest", "nearest" )
	lm.setVisible( false )
	
	icon = lg.newImage( 'icon.png' )
	lg.setIcon( icon )

end


function love.update( dt )

	mx, my = lm.getX(), lm.getY()
	mouse_hitbox = { x = lm.getX(), y = lm.getY(), w = 1, h = 1 }
	
	gamestate.update( dt )

	fader:update( dt )

end


function love.draw()

	gamestate.draw()
	fader:draw()
	
	lg.setColor( 255, 255, 255 )
	--lg.print( "FPS: "..lt.getFPS(), 30, 30 )
	
	lg.draw( cursor, mx, my, 0, 2, 2 )


end


function love.keypressed( key )

	gamestate.keypressed( key )

end


function love.mousepressed( x, y, b )

	gamestate.mousepressed( x, y, b )

end


function boxCollide(rect1, rect2) --Jeweils x, y, w und h bentigt
	
	local rect1x2 , rect1y2 , rect2x2 , rect2y2 = rect1.x + rect1.w, rect1.y + rect1.h, rect2.x + rect2.w , rect2.y + rect2.h
  
	return rect1.x < rect2x2 and rect1x2 > rect2.x and rect1.y < rect2y2 and rect1y2 > rect2.y
  
end


function love.focus( f )

	if not f then game.pause = true end

end